`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2018/03/29 20:12:21
// Design Name: 
// Module Name: FSM
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define STAT_PAUSE 1'b0
`define STAT_COUNT 1'b1
`define ENABLED 1'b1
`define DISABLED 1'b0

module FSM(
count_enable, // if counter is enabled
in, //input control
clk, // global clock signal
rst, // high active reset
state
);

// outputs
output count_enable; // if counter is enabled

// inputs
input clk; // global clock signal
input rst; // high active reset
input in; //input control
output state; // state of FSM
reg count_enable; // if counter is enabled
reg next_state; // next state of FSM
reg state;

// FSM state decision
always @*
  case (state)
    `STAT_PAUSE:
    if (in)
        begin
        next_state = `STAT_COUNT;
        count_enable = `ENABLED;
        end
    else
        begin
        next_state = `STAT_PAUSE;
        count_enable = `DISABLED;
        end
    `STAT_COUNT:
    if (in)
        begin
        next_state = `STAT_PAUSE;
        count_enable = `DISABLED;
        end
    else
        begin
        next_state = `STAT_COUNT;
        count_enable = `ENABLED;
        end
  default:
      begin
      next_state = `STAT_PAUSE;
      count_enable = `DISABLED;
      end
    endcase
    
    // FSM state transition
always @(posedge clk or posedge rst)
    if (rst)
        state <= `STAT_PAUSE;
    else
        state <= next_state;
    
    endmodule
